    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2008, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * --------------
    028     * ValueTick.java
    029     * --------------
    030     * (C) Copyright 2003-2008, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * Changes
    036     * -------
    037     * 07-Nov-2003 : Version 1 (DG);
    038     * 02-Aug-2007 : Added tick type attribute (DG);
    039     *
    040     */
    041
    042    package org.jfree.chart.axis;
    043
    044    import org.jfree.ui.TextAnchor;
    045
    046    /**
    047     * A value tick.
    048     */
    049    public abstract class ValueTick extends Tick {
    050
    051        /** The value. */
    052        private double value;
    053
    054        /**
    055         * The tick type (major or minor).
    056         *
    057         * @since 1.0.7
    058         */
    059        private TickType tickType;
    060
    061        /**
    062         * Creates a new value tick.
    063         *
    064         * @param value  the value.
    065         * @param label  the label.
    066         * @param textAnchor  the part of the label that is aligned to the anchor
    067         *                    point.
    068         * @param rotationAnchor  defines the rotation point relative to the label.
    069         * @param angle  the rotation angle (in radians).
    070         */
    071        public ValueTick(double value, String label,
    072                         TextAnchor textAnchor, TextAnchor rotationAnchor,
    073                         double angle) {
    074
    075            this(TickType.MAJOR, value, label, textAnchor, rotationAnchor, angle);
    076            this.value = value;
    077
    078        }
    079
    080        /**
    081         * Creates a new value tick.
    082         *
    083         * @param tickType  the tick type (major or minor).
    084         * @param value  the value.
    085         * @param label  the label.
    086         * @param textAnchor  the part of the label that is aligned to the anchor
    087         *                    point.
    088         * @param rotationAnchor  defines the rotation point relative to the label.
    089         * @param angle  the rotation angle (in radians).
    090         *
    091         * @since 1.0.7
    092         */
    093        public ValueTick(TickType tickType, double value, String label,
    094                         TextAnchor textAnchor, TextAnchor rotationAnchor,
    095                         double angle) {
    096
    097            super(label, textAnchor, rotationAnchor, angle);
    098            this.value = value;
    099            this.tickType = tickType;
    100        }
    101
    102        /**
    103         * Returns the value.
    104         *
    105         * @return The value.
    106         */
    107        public double getValue() {
    108            return this.value;
    109        }
    110
    111        /**
    112         * Returns the tick type (major or minor).
    113         *
    114         * @return The tick type.
    115         *
    116         * @since 1.0.7
    117         */
    118        public TickType getTickType() {
    119            return this.tickType;
    120        }
    121
    122        /**
    123         * Tests this tick for equality with an arbitrary object.
    124         *
    125         * @param obj  the object to test (<code>null</code> permitted).
    126         *
    127         * @return A boolean.
    128         */
    129        public boolean equals(Object obj) {
    130            if (obj == this) {
    131                return true;
    132            }
    133            if (!(obj instanceof ValueTick)) {
    134                return false;
    135            }
    136            ValueTick that = (ValueTick) obj;
    137            if (this.value != that.value) {
    138                return false;
    139            }
    140            if (!this.tickType.equals(that.tickType)) {
    141                return false;
    142            }
    143            return super.equals(obj);
    144        }
    145
    146    }